



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>BZOJ1855或洛谷2569 [SCOI2010]股票交易</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">BZOJ1855或洛谷2569 [SCOI2010]股票交易</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-25 15:25:42 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>一道单调队列优化\(DP\)</strong></p>
<h3><a href="https://www.lydsy.com/JudgeOnline/problem.php?id=1855" rel="external nofollow noreferrer">BZOJ原题链接</a></h3>
<h3><a href="https://www.luogu.org/problemnew/show/P2569" rel="external nofollow noreferrer">洛谷原题链接</a></h3>
<p>朴素的\(DP\)方程并不难想。<br /><br />
定义\(f[i][j]\)表示到第\(i\)天，手上持有\(j\)股时的最大收益。<br /><br />
转移方程可以分成四个部分。</p>
<ol><li>第\(i\)天为空手时买股票</li></ol>
<h2>\(\qquad\qquad f[i][j]=-AP_i\times j\)</h2>
<ol><li>第\(i\)天不进行交易</li></ol>
<h2>\(\qquad\qquad f[i][j]=\max\{f[i][j],f[i-1][j]\}\)</h2>
<ol><li>第\(i\)天在之前基础上买</li></ol>
<h2>\(\qquad\qquad f[i][j]=\max\limits_{k=\max\{j-AS_i,1\}}^{j-1}\{f[i][j],f[i-w-1][k]-AP_i\times (j-k)\}\)</h2>
<ol><li>第\(i\)天在之前基础上卖</li></ol>
<h2>\(\qquad\qquad f[i][j]=\max\limits_{k=j+1}^{\min\{j+BS_i,MaxP\}}\{f[i][j],f[i-w-1][k]+BP_i\times (k-j)\}\)</h2>
<p>显然决策增减满足单调性，可以用单调队列维护，注意第\(4\)项要倒序才能维护。</p>
<pre class="prettyprint linenums"><code>#include&lt;cstdio&gt;<br />
#include&lt;cstring&gt;<br />
using namespace std;<br />
const int N = 2010;<br />
int f[N][N], AP[N], BP[N], AS[N], BS[N], q[N];<br />
int re()<br />
{<br />
	int x = 0;<br />
	char c = getchar();<br />
	bool p = 0;<br />
	for (; c&lt;'0' || c&gt;'9'; c = getchar())<br />
		p = (c == '-' || p) ? 1 : 0;<br />
	for (; c &gt;= '0'&amp;&amp;c &lt;= '9'; c = getchar())<br />
		x = x * 10 + (c - '0');<br />
	return p ? -x : x;<br />
}<br />
inline int minn(int x, int y)<br />
{<br />
	return x &lt; y ? x : y;<br />
}<br />
inline int maxn(int x, int y)<br />
{<br />
	return x &gt; y ? x : y;<br />
}<br />
int main()<br />
{<br />
	int i, j, n, m, w, l, r;<br />
	n = re();<br />
	m = re();<br />
	w = re();<br />
	memset(f, 250, sizeof(f));<br />
	for (i = 1; i &lt;= n; i++)<br />
	{<br />
		AP[i] = re();<br />
		BP[i] = re();<br />
		AS[i] = re();<br />
		BS[i] = re();<br />
		f[i][0] = 0;<br />
	}<br />
	for (i = 1; i &lt;= n; i++)<br />
	{<br />
		for (j = 0; j &lt;= AS[i]; j++)<br />
			f[i][j] = -AP[i] * j;<br />
		for (j = m; j &gt;= 0; j--)<br />
			f[i][j] = maxn(f[i][j], f[i - 1][j]);<br />
		if (i - w - 1 &gt; 0)<br />
		{<br />
			for (r = j = 0, l = 1; j &lt;= m; j++)<br />
			{<br />
				while (l &lt;= r &amp;&amp; q[l] &lt; j - AS[i])<br />
					l++;<br />
				while (l &lt;= r &amp;&amp; f[i - w - 1][j] + AP[i] * j &gt;= f[i - w - 1][q[r]] + AP[i] * q[r])<br />
					r--;<br />
				q[++r] = j;<br />
				if (l &lt;= r)<br />
					f[i][j] = maxn(f[i][j], f[i - w - 1][q[l]] - AP[i] * (j - q[l]));<br />
			}<br />
			for (r = 0, l = 1, j = m; j &gt;= 0; j--)<br />
			{<br />
				while (l &lt;= r &amp;&amp; q[l] &gt; j + BS[i])<br />
					l++;<br />
				while (l &lt;= r &amp;&amp; f[i - w - 1][j] + BP[i] * j &gt;= f[i - w - 1][q[r]] + BP[i] * q[r])<br />
					r--;<br />
				q[++r] = j;<br />
				if (l &lt;= r)<br />
					f[i][j] = maxn(f[i][j], f[i - w - 1][q[l]] + BP[i] * (q[l] - j));<br />
			}<br />
		}<br />
	}<br />
	printf(&quot;%d&quot;, f[n][0]);<br />
	return 0;<br />
}<br />
</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93ror93.html">Mono的简单例子</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxkeg08.html">我的CodeF水A题之路</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r707e8.html">Ninject之旅之三：Ninject对象生命周期</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93lxxz9.html">本地wampserver如何配置伪静态</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pzezz8.html">第六步：Lucene查询索引</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn11g038.html">php ajax json jquery 记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnkz72q.html">新网注册域名如何转向其他&lpar;如花生壳&rpar;DNS（不会报错，已经转入成功）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmvj5e9.html">java security</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1oz138.html">转载：mysql-Auto&lowbar;increment值修改</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w4r2wq.html">zoj2314 经典 无源汇有上下界最大流 并输出可行流</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mekjjoq.html">Spring 加载静态资源</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy16x0gq.html">201521123074 《Java程序设计》第10周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzgdle8.html">我的java学习之路--Reflect专题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzrlw48.html">通过Activity动态加载Fragment创建主界面构架</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgrzpr8.html">Linux根文件系统介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jovyl8.html">react 源码之setState</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1ngeeq.html">tomcat&colon; 类加载器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdljoe9.html">luogu P1816 【忠诚】</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j7l2eq.html">docker上部署nginx容器80端口自动转443端口</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2xyloq.html">ES6学习之变量的解构赋值</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pw0x378.html">CSS 盒子大小</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllgkg1q.html">MATLAB 提取头发（最大连通域）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jrdgnq.html">ubuntu下安装nodejs和npm</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjy2639.html">BlockingQueue  解析</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pw0vxk8.html">IDEA中配置Maven&plus;spring MVC&plus;tomcat</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjydl39.html">百度浏览器 UserAgent</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pw0yvk8.html">【收藏】UI自动化测试基本规则与设计模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rz0mn9.html">MySQL千万级数据分区存储及查询优化</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjy6d69.html">js和jquery实现图片无缝轮播的不同写法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jr1mjq.html">截图原理（一）&mdash;&mdash;Android自动化测试学习历程</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
